
let Spyro = (Spyro || {});
let Field = Spyro.Field
let Text = Spyro.Text

let e = function() {

  class Base extends React.Component {
    constructor(props) {
      super(props);
      this.handleTextChange = this.handleTextChange.bind(this)
      this.handleEdition = this.handleEdition.bind(this)
      this.save = this.save.bind(this)
      this.modelName = _.snakeCase(this.constructor.name)
      this.created = (_.keys(props).includes("id"))
      this._setupProperties(props)

      console.log("Constructor")
    }

    _setupProperties(props) {
      let urlBase = `/${pluralize.plural(this.modelName)}`
      if (this.created)
      {
        urlBase += `/${props.id}`
      }

      if (this.state === undefined)
      {
        this.state = {}
      }
      this.state = _.extend({attributes: props, editing: false, url: urlBase}, this.state)
      return true;
    }

    componentDidMount () {
      console.log("mounted")
    }

    handleTextChange (e) {
      let new_attributes = this.state.attributes
      new_attributes[e.target.attributes.getNamedItem("data-field").value] = e.target.value
      this.setState({attributes: new_attributes});
      e.target.focus();
      return true;
    }

    handleEdition (e) {
      // console.log(this)
      if (this) {
        this.setState({editing: (this.state.editing ? false : true)});
      }
    }

    render () {
      let className = `${this.modelName} object-component`
      return (
        <div className={className}>
          {(this.state.editing ? this.updateForm() : this.displayDom())}
        </div>
      );
    }

    displayDom () {
      console.log(this.state)
      console.log(this.constructor.propTypes)
      let self = this
      let fieldsDom = _.map(this.state.attributes, (value, name) => {
        return this._domForItem(name, value)
        return (<p key={name}>
          <b>{name}</b>:
          <span onClick={this.handleEdition} className={className}>{value}</span>
        </p>)
      })
      return (
        <div>
          {fieldsDom}
        </div>
      );
    }

    _domForItem(name, item) {

      console.log("Looking for array: ", Object.prototype.toString.call(item) === '[object Array]', item)
      console.log("Looking for object: ",Object.prototype.toString.call(item) === '[object Object]', item)
      if (Object.prototype.toString.call(item) === '[object Array]')
      {
        return _.map(item, (e) => { return this._domForItem(name, e)})
      }
      else if (Object.prototype.toString.call(item) === '[object Object]')
      {
        let objectName = _.startCase(name).replace(/s$/, '').replace(' ', '');
        console.log("Object name: ", objectName)
        if (typeof(window[objectName]) === "function")
        {
          let Component = window[objectName]
          console.log("component: ", Component)
          return (<Component {...item} />)
        }
      }
      let className = `${this.modelName}-edit-field-${item}`;

      return (
        <p key={name}>
          <b>{name}</b>:
          <span onClick={this.handleEdition} className={className}>{item}</span>
        </p>
      )
    }

    fieldFor(name, value, addons = {})
    {
      if (this.constructor.Types && this.constructor.Types[name])
      {
        let dataType =  this.constructor.Types[name]
        let CustomField = Field[_.startCase(dataType).replace(/s$/, '').replace(' ', '')]
        console.log("CustomField: ", CustomField)
        return (<CustomField name={name} value={value} {...addons} />)
      }
      else
      {
        console.log("Text: ", Text)
        return (<Text name={name} value={value} {...addons} />)
      }
    }

    updateForm () {
      let fieldsDom = _.map(this.state.attributes, (value, name) => {
        let className = `${this.modelName}-edit-field-${value} input__field`;
        let inputName = `${this.modelName}[${name}]`;
        return (this.fieldFor(name, value, {onChange: this.handleTextChange, 'data-field': name, className: className}))
        // return <Field name={name} value={value} className={className} />
        // return <p key={name}><b>{name}</b>: <input type="text" onChange={this.handleTextChange} data-field={name} name={inputName} value={value} className={className}/></p>
      })
      return (
        <form action={this.state.url} onSubmit={this.save} method={this._updateMethod()}>
          {fieldsDom}
          <button type="submit">Save</button>
          <button onClick={this.handleEdition} type="button">Back</button>
        </form>
      );
    }

    save (e = false) {
      if (e) {
        e.preventDefault()
      }
      let action = `${this.state.url}.json`
      let method = this._updateMethod()
      let data = {}
      data[this.modelName] = this.state.attributes
      $.signedAjax({
        method: method,
        url: action,
        data: data
      })
      .success((data) =>
      {
        console.log("SUCCESS ! ", data)
        console.log(this)
        this.handleEdition()
      })
      .error((a, b, c) => {
        console.warn("ERROR", a, b, c)
      })
    }

    refresh () {

    }

    _fetch (url) {

    }

    _url () {

    }

    _updateMethod () {
      return (this.created ? this._method().update : this._method().create)
    }

    _method () {
      return {
        show: "GET",
        index: "GET",
        update: "PATCH",
        create: "POST",
        destroy: "DELETE"
      }
    }
  }

  Spyro.Base = Base
}()

