
let Spyro = (Spyro || {});
let Field = Spyro.Field
let Text = Spyro.Text

class Element extends React.Component {

  constructor(props) {
    super(props)
    this.props.onClick = (props.onClick || this.handleEdition.bind(this))
    this.model = props.model || ""
    this.state = {
      editing: props.editing || false,
      raw: props.raw || false,
    }
  }

  handleEdition () {
    this.setState({editing: (this.state.editing ? false : true)});
  }

  isNull() {
    return (this.props.value === null || this.props.value === undefined);
  }

  isNumeric() {
    return (typeof(this.props.value) === "number" ||
      (typeof(this.props.value) === "string" && this.props.value.match(/^\d*$/) != null));
  }

  isDate() {
    return (
      (typeof(this.props.value) === "object" && this.props.value.constructor.name == "Date") ||
      (typeof(this.props.value) === "string" && Date.parse(this.props.value) > 0)
    )
  }

  isArray() {
    return (typeof(this.props.value) === "object")
  }

  isObject() {
    return (typeof(this.props.value) === "object")
  }

  isCoordinates() {
    return false
  }

  isUrl() {
    var urlRegex =/(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;   
    return (typeof(this.props.value) === "string" && this.props.value.match(urlRegex) != null)
  }

  isImage() {
    return (typeof(this.props.value) === "string" && this.props.value.match(/\.(gif|jpg|jpeg|tiff|png)$/i) != null)
  }

  display() {
    if (this.isNull() || this.isNumeric())
    {
      return (this.props.value)
    }
    else if (this.isDate())
    {
      return moment(new Date(this.props.value)).twitter()
    }
    else if (this.isObject())
    {

    }
    else if (this.isObject())
    {
      if (this.props.value.name)
      {
        let url = this.props.value.url || (this.props.value.id && `/${pluralize(this.props.name)}/${this.props.value.id}`)
        return (url ? (<a href={url}>{this.props.value.name}</a>) : this.props.value.name)
      }
      else
      {
        this.props.value.toString()
      }
    }
    else if (this.isImage())
    {
      // return <img className="lazy" data-src={this.props.value} src={this.props.value.replace("/original/", "/cap36/")}/>
      return <img src={this.props.value}/>
    }
    else if (this.isUrl())
    {
      var link = _.truncate(this.props.value)
      return <a href={this.props.value}>{link}</a>
    }
    else
    {
      return (this.props.value)
    }
  }

  onChange (e) {
    console.log("Change !", e, e.target)
  }

  edit() {
    let inputName = `${this.model}${this.props.name}`
    return (<input onChange={this.onChange.bind(this)} type="text" name={inputName} value={this.props.value} />);
    if (this.isNull())
    {
      return (this.props.value)
    }
    else if (this.isNumeric())
    {
      return moment(new Date(this.props.value)).calendar()
    }
    else if (this.isDate())
    {
      return moment(new Date(this.props.value)).calendar()
    }
    else
    {
      return (this.props.value)
    }
  }

  render () {
    // let renderMethod = (this.state.editing ? this.edit.bind(this) : this.display.bind(this))
    let renderMethod = this.display.bind(this)
    return (
      <span onClick={this.props.onClick}>{renderMethod()}</span>
    );
  }
}


