module ActiveRecord
  class Base
    def self.primary_key
      "id"
    end

    def primary_key
      "id"
    end

    def to_desc *args
      self.send self.to_desc_sym *args
    end

    def to_desc_sym *args
      self.respond_to?(:name) ? :name : :id
    end

    def self.default field, value, opts = {}
      opts = {:forced => false, :method => :blank?, :action => :before_validation}.merge opts
      fct = "#{field}_#{opts[:action]}".to_sym

      self.send(opts[:action], fct)

      define_method fct do
        return true if opts[:if]      and not opts[:if].call(*(opts[:if].arity.zero? ? [] : [self]))
        return true if opts[:unless]  and     opts[:unless].call(*(opts[:unless].arity.zero? ? [] : [self]))

        if opts[:forced] == true or self.send(field.to_sym).send(opts[:method])
          final_value = value.respond_to?(:call) ? value.call(*(value.arity.zero? ? [] : [self])) : value
          self.send("#{field.to_sym}=", final_value)
        end

        true
      end
    end
  end
end
