require_relative "base"
require "csv"


module Spyro
  module ActionViewExtension

    module CollectionForHelper
      module Output
        class CSV < Output::Base

          def render_header csv
            return unless @unicollection.meta[:data]
            csv << @unicollection.meta[:data]
          end

          def render_body csv
            @unicollection.rows.each do |row|
              csv << row[:data].map(&:value)
            end
          end

          def render
            return "" if @unicollection.rows.empty?
            ::CSV.generate({}) do |csv|
              render_header csv
              render_body csv
            end
          end
        end
      end
    end
  end
end
