require_relative "table"

module Spyro
  module ActionViewExtension
    module CollectionForHelper
      module Output
        class FlatuiTable < Table
          delegate :link_to, :button, :button_success, :button_danger, :button_info, to: :@h

          def initialize unicollection, helper, parser_class
            super
          end

          def render_cell_buttons row
            row[:meta][:actions] = {} if row[:meta][:actions].nil?

            html = if row[:meta][:actions].is_a? Hash
                     row[:meta][:actions].map do |name, link|
                       case name
                         when :show
                           button_success "", link, :icon => :search, :class => 'btn btn-lg'
                         when :edit
                           button_info "", link, :icon => :edit, :class => "btn btn-lg"
                         when :destroy
                           button_danger "", link, default_destroy_link_attributes.merge(:icon => :trash, :class => "btn btn-lg")
                         else
                           button "", link, :icon => :name, :class => "btn btn-lg"
                       end
                     end.join ''
                   else
                     row[:meta][:actions]
                   end

            "<td>#{html}</td>"
          end
        end
      end
    end
  end
end
