require_relative "table"

module Spyro
  module ActionViewExtension

    module CollectionForHelper
      module Output
        class InplaceTable < Table
          def initialize unicollection, helper, parser_class
            raise "InplaceTable: Bad parser class (#{parser_class} instead of CollectionForHelper::Parser::Model)" if parser_class != CollectionForHelper::Parser::Model
            super
          end

          def data_type elem
            "input"
          end

          def custom_value_formatted value, elem
            if elem.name.to_sym.in? [:header, :id, :created_at, :updated_at]
              value
            else
              "<span class='best_in_place' data-type='#{data_type elem}' data-url='#{@unicollection.meta[:show]}' data-object='#{@unicollection.meta[:model_class].to_s.underscore}' data-attribute='#{elem.name}' data-type='input'>#{value}</span>"
            end
          end
        end
      end
    end
  end
end
