require_relative "base"

module Spyro
  module ActionViewExtension

    module CollectionForHelper
      module Output
        class XLSX < Output::Base
          def render_header sheet
            return unless @unicollection.meta[:data]
            sheet.add_row @unicollection.meta[:data]
          end

          def render_body sheet
            @unicollection.rows.each do |row|
              sheet.add_row row[:data].map(&:value)
            end
          end

          def render
            return "" if @unicollection.rows.empty?

            filename = @unicollection.meta[:filename] || @unicollection.meta[:model_class] || "file"
            xlsx_package = Axlsx::Package.new({})
            wb = xlsx_package.workbook


            wb.add_worksheet(name: filename) do |sheet|
              render_header sheet
              render_body sheet
            end

            xlsx_package.to_stream.string
          end
        end
      end
    end
  end
end
