require_relative "active_record_relation"

module Spyro
  module ActionViewExtension

    module CollectionForHelper
      module Parser
        class Array < Parser::ActiveRecordRelation
          @@types[::Array] = self

          def initialize model, helper, options
            super
            @array = @collection
          end

          def parse
            if @array.first.try(:is_a?, ActiveRecord::Base)
              super
              return
            end
            if @unicollection.rows.empty?
              @array.each do |row|
                @unicollection.row do |r|
                  [*row].each do |elem|
                    r.add_elem UniData::Element.new(value: elem, name: "header", type: elem.class)
                  end
                end
              end
            end

            @unicollection.add_meta :header, @unicollection.meta[:data]
          end
        end
      end
    end

  end
end
