
module Spyro
  module ActionViewExtension

    module CollectionForHelper
      module Parser
        class Base

          mattr_accessor :types
          attr_accessor :unicollection

          delegate :polymorphic_path, :edit_polymorphic_path, to: :@h

          @@types = {}

          def initialize collection, helper, options
            @h = helper
            @collection = collection
            @options = options

            @unicollection = UniData::Collection.new
            options.each do |key, value|
              @unicollection.add_meta key, value
            end
          end

          def link model_belong
            final_link = polymorphic_path([@options[:parents].first, model_belong]) rescue nil
            final_link = polymorphic_path([*@options[:parents], model_belong]) rescue nil if final_link.nil?
            final_link
          end

          def hash_for_name model, name
            #value = model[name] # en vrai
            value = model.send(name) # intra

            if name =~ /(.+)_id$/
              model_belong = model.send($1) rescue nil
              if model_belong
                link = link(model_belong) rescue nil
                return {value: model_belong.try(:to_desc) || model_belong.try(:name) || model_belong.id,
                        type: String, name: name, db_type: String, link: link}
              end
            end
            {value: value, type: value.class, name: name, db_type: (model.has_attribute?(name) ? model.type_for_attribute(name) : nil)}
          end

          def method_missing method, args
            @unicollection.add_meta method, args
          end

          def parse_default
          end

        end
      end
    end

  end
end
