require_relative "base"

module Spyro
  module ActionViewExtension
    module CollectionForHelper
      module Parser
        class Model < Parser::Base
          @@types[::ActiveRecord::Base] = self

          def initialize model, helper, options
            super
            @model = @collection
            @unicollection.add_meta :model_class, model.class
            @unicollection.add_meta :show, polymorphic_path([*options[:parents], model]) rescue nil
          end

          def parse
            (@unicollection.meta[:data] || @model.attributes).each do |name, val|
              @unicollection.row do |r|
                hash = hash_for_name(@model, name)
                r.add_elem UniData::Element.new(value: name, name: "header", type: String, translate: true)
                r.add_elem UniData::Element.new(hash)
              end
            end

          end
        end
      end
    end
  end
end
